var _excluded = ["text", "mode", "format", "render", "renderFormItem", "showTime", "fieldProps"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState, useRef, useImperativeHandle } from 'react';
import dayjs from 'dayjs';
import { useIntl, parseValueToDayjs } from '@g3-cscec/app-sdk';
import DatePickerWithDayjs from './DatePickerWithDayjs';

var G3FieldRangePicker = function G3FieldRangePicker(_ref, ref) {
  var text = _ref.text,
      mode = _ref.mode,
      format = _ref.format,
      render = _ref.render,
      renderFormItem = _ref.renderFormItem,
      showTime = _ref.showTime,
      _ref$fieldProps = _ref.fieldProps,
      fieldProps = _ref$fieldProps === void 0 ? {} : _ref$fieldProps,
      rest = _objectWithoutProperties(_ref, _excluded);

  var intl = useIntl();

  var _ref2 = Array.isArray(text) ? text : [],
      _ref3 = _slicedToArray(_ref2, 2),
      startText = _ref3[0],
      endText = _ref3[1];

  var g3Ref = useRef({
    focus: function focus() {},
    blur: function blur() {}
  });

  var _useState = useState(fieldProps.open),
      _useState2 = _slicedToArray(_useState, 2),
      open = _useState2[0],
      setOpen = _useState2[1];

  useImperativeHandle(ref, function () {
    return _objectSpread(_objectSpread({}, g3Ref.current), {}, {
      focus: function focus() {
        g3Ref.current.focus();
        setOpen(true);
      }
    });
  });

  var onBlur = function onBlur() {
    if (open) return;

    var _rest$fieldProps = _objectSpread(_objectSpread({}, rest), fieldProps),
        onBlur = _rest$fieldProps.onBlur;

    if (onBlur && typeof onBlur === 'function') onBlur();
  };

  var onChange = function onChange(_ref4) {
    var _ref5 = _slicedToArray(_ref4, 2),
        start = _ref5[0],
        end = _ref5[1];

    var _fieldProps$rest = _objectSpread(_objectSpread({}, fieldProps), rest),
        _fieldProps$rest$onCh = _fieldProps$rest.onChange,
        onChange = _fieldProps$rest$onCh === void 0 ? undefined : _fieldProps$rest$onCh;

    onChange && onChange([start.valueOf(), end.valueOf()]);
  };

  var parsedStartText = startText ? dayjs(startText).format((fieldProps === null || fieldProps === void 0 ? void 0 : fieldProps.format) || format || 'YYYY-MM-DD') : '';
  var parsedEndText = endText ? dayjs(endText).format((fieldProps === null || fieldProps === void 0 ? void 0 : fieldProps.format) || format || 'YYYY-MM-DD') : '';

  if (mode === 'read') {
    var dom = /*#__PURE__*/React.createElement("div", {
      ref: ref
    }, /*#__PURE__*/React.createElement("div", null, parsedStartText || '-', "~", parsedEndText || '-'));

    if (render) {
      return render(text, _objectSpread({
        mode: mode
      }, fieldProps), /*#__PURE__*/React.createElement("span", null, dom));
    }

    return dom;
  }

  if (mode === 'edit' || mode === 'update') {
    var momentValue = parseValueToDayjs(fieldProps === null || fieldProps === void 0 ? void 0 : fieldProps.value);
    var startPlaceholderText = intl.getMessage('tableForm.selectPlaceholder', '请选择');
    var endPlaceholderText = intl.getMessage('tableForm.selectPlaceholder', '请选择');

    var _dom = /*#__PURE__*/React.createElement(DatePickerWithDayjs.RangePicker, _extends({
      bordered: "true",
      ref: g3Ref,
      format: format,
      showTime: showTime,
      placeholder: [startPlaceholderText, endPlaceholderText]
    }, rest, fieldProps, {
      value: momentValue,
      open: open,
      onOpenChange: setOpen,
      onBlur: onBlur,
      onChange: onChange
    }));

    if (renderFormItem) {
      return renderFormItem(text, _objectSpread({
        mode: mode
      }, fieldProps), _dom);
    }

    return _dom;
  }

  return null;
};

export default /*#__PURE__*/React.forwardRef(G3FieldRangePicker);