var _excluded = ["text", "valueType", "onChange", "value"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import { omitUndefined, pickProProps, useIntl } from '@g3-cscec/app-sdk';
import { G3Text, G3TextArea, G3Number, G3DatePicker, G3RangePicker, G3TimePicker, G3Switch, G3Radio, G3Checkbox, G3Select, G3TreeSelect } from '..';
import "./index.css";

var defaultRenderComponent = function defaultRenderComponent(text, valueType, props) {
  delete props.emptyText;

  if (valueType === 'textarea') {
    return /*#__PURE__*/React.createElement(G3TextArea, _extends({
      text: text
    }, props));
  }

  if (valueType === 'number') {
    return /*#__PURE__*/React.createElement(G3Number, _extends({
      text: text
    }, props));
  }

  if (valueType === 'date') {
    return /*#__PURE__*/React.createElement(G3DatePicker, _extends({
      text: text,
      format: "YYYY-MM-DD"
    }, props));
  }

  if (valueType === 'dateRange') {
    return /*#__PURE__*/React.createElement(G3RangePicker, _extends({
      text: text,
      format: "YYYY-MM-DD"
    }, props));
  }

  if (valueType === 'timePicker') {
    return /*#__PURE__*/React.createElement(G3TimePicker, _extends({
      text: text,
      format: "HH:mm:ss"
    }, props));
  }

  if (valueType === 'select' || valueType === 'text' && (props.valueEnum || props.request)) {
    return /*#__PURE__*/React.createElement(G3Select, _extends({
      text: text
    }, props));
  }

  if (valueType === 'treeSelect') {
    return /*#__PURE__*/React.createElement(G3TreeSelect, _extends({
      text: text
    }, props));
  }

  if (valueType === 'checkbox') {
    return /*#__PURE__*/React.createElement(G3Checkbox, _extends({
      text: text
    }, props));
  }

  if (valueType === 'radio') {
    return /*#__PURE__*/React.createElement(G3Radio, _extends({
      text: text
    }, props));
  }

  if (valueType === 'radioButton') {
    return /*#__PURE__*/React.createElement(G3Radio, _extends({
      radioType: "button",
      text: text
    }, props));
  }

  if (valueType === 'switch') {
    return /*#__PURE__*/React.createElement(G3Switch, _extends({
      text: text
    }, props));
  }

  return /*#__PURE__*/React.createElement(G3Text, _extends({
    text: text
  }, props));
};

var G3Field = function G3Field(_ref, ref) {
  var _ref2;

  var text = _ref.text,
      _ref$valueType = _ref.valueType,
      valueType = _ref$valueType === void 0 ? 'text' : _ref$valueType,
      _onChange = _ref.onChange,
      value = _ref.value,
      rest = _objectWithoutProperties(_ref, _excluded);

  var intl = useIntl();

  var fieldProps = (value !== undefined || _onChange || (rest === null || rest === void 0 ? void 0 : rest.fieldProps)) && _objectSpread(_objectSpread({
    value: value
  }, omitUndefined(rest === null || rest === void 0 ? void 0 : rest.fieldProps)), {}, {
    onChange: function onChange() {
      var _rest$fieldProps, _rest$fieldProps$onCh;

      for (var _len = arguments.length, restParams = new Array(_len), _key = 0; _key < _len; _key++) {
        restParams[_key] = arguments[_key];
      }

      console.log(restParams);
      _onChange === null || _onChange === void 0 ? void 0 : _onChange.apply(void 0, restParams);
      rest === null || rest === void 0 ? void 0 : (_rest$fieldProps = rest.fieldProps) === null || _rest$fieldProps === void 0 ? void 0 : (_rest$fieldProps$onCh = _rest$fieldProps.onChange) === null || _rest$fieldProps$onCh === void 0 ? void 0 : _rest$fieldProps$onCh.call.apply(_rest$fieldProps$onCh, [_rest$fieldProps].concat(restParams));
    }
  });

  return /*#__PURE__*/React.createElement(React.Fragment, null, defaultRenderComponent((_ref2 = text !== null && text !== void 0 ? text : fieldProps === null || fieldProps === void 0 ? void 0 : fieldProps.value) !== null && _ref2 !== void 0 ? _ref2 : '', valueType || 'text', _objectSpread(_objectSpread({}, rest), {}, {
    mode: rest.mode || 'read',
    ref: ref,
    placeholder: rest.placeholder || intl.getMessage('tableForm.inputPlaceholder', '请输入'),
    fieldProps: pickProProps(fieldProps)
  })));
};

G3Field.displayName = 'G3Field';
export default /*#__PURE__*/React.forwardRef(G3Field);