var _excluded = ["menuType", "subItems", "children"],
    _excluded2 = ["items", "children"];

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useImperativeHandle, useState } from 'react';
import { Menu } from 'antd';
import G3MenuSub from './G3MenuSub';
import G3MenuItem from './G3MenuItem';
import G3MenuItemGroup from './G3MenuItemGroup';
import G3MenuDivider from './G3MenuDivider';
import { MENU_TYPES } from '../types';
var menuCom = [G3MenuItem, G3MenuSub, G3MenuItemGroup, G3MenuDivider];

var loop = function loop(items) {
  return items.length ? items.map(function (_ref) {
    var _ref$menuType = _ref.menuType,
        menuType = _ref$menuType === void 0 ? MENU_TYPES.ITEM : _ref$menuType,
        subItems = _ref.subItems,
        children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded);

    var MenuCom = menuCom[menuType];

    if (subItems && subItems.length) {
      return /*#__PURE__*/React.createElement(MenuCom, rest, loop(subItems));
    }

    return /*#__PURE__*/React.createElement(MenuCom, rest, children);
  }) : null;
};

var G3Menu = function G3Menu(props, ref) {
  var items = props.items,
      children = props.children,
      rest = _objectWithoutProperties(props, _excluded2);

  var _useState = useState(true),
      _useState2 = _slicedToArray(_useState, 2),
      visible = _useState2[0],
      _setVisible = _useState2[1];

  var menuChildren = items && items.length ? loop(items) : children;
  useImperativeHandle(ref, function () {
    return {
      setVisible: function setVisible(visible) {
        _setVisible(visible);
      }
    };
  });
  return visible ? /*#__PURE__*/React.createElement(Menu, rest, menuChildren) : null;
};

export default /*#__PURE__*/React.forwardRef(G3Menu);