var _excluded = ["className", "buttonShowNum", "buttonList", "extra"],
    _excluded2 = ["key", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useImperativeHandle, useState } from 'react';
import { PageHeader } from 'antd';
import classnames from 'classnames';
import { EllipsisOutlined } from '@ant-design/icons';
import { MENU_TYPES } from '../types';
import G3Button from '../button/G3Button';
import G3Menu from '../menu/G3Menu';
import G3Dropdown from '../dropdown/G3Dropdown';
import "./index.css";

var G3PageHeader = function G3PageHeader(props, ref) {
  var className = props.className,
      _props$buttonShowNum = props.buttonShowNum,
      buttonShowNum = _props$buttonShowNum === void 0 ? 3 : _props$buttonShowNum,
      buttonList = props.buttonList,
      extra = props.extra,
      rest = _objectWithoutProperties(props, _excluded);

  var _useState = useState(true),
      _useState2 = _slicedToArray(_useState, 2),
      visible = _useState2[0],
      _setVisible = _useState2[1];

  var buttonExtra;

  if (buttonList && buttonList.length) {
    var showBtnList = buttonList.slice(0, buttonShowNum);
    var hideBtnList = buttonList.slice(buttonShowNum);
    buttonExtra = showBtnList.map(function (_ref) {
      var key = _ref.key,
          children = _ref.children,
          rest = _objectWithoutProperties(_ref, _excluded2);

      return /*#__PURE__*/React.createElement(G3Button, _extends({
        key: key
      }, rest), children);
    });
    var hideMenu = hideBtnList.map(function (item) {
      return _objectSpread({
        menuType: MENU_TYPES.ITEM
      }, item);
    });
    buttonExtra.push( /*#__PURE__*/React.createElement(G3Dropdown, {
      key: "g3-page-header-dropdown-key",
      overlay: /*#__PURE__*/React.createElement(G3Menu, {
        items: hideMenu
      })
    }, /*#__PURE__*/React.createElement(G3Button, {
      style: {
        border: 'none',
        padding: 0
      }
    }, /*#__PURE__*/React.createElement(EllipsisOutlined, {
      style: {
        fontSize: 20,
        verticalAlign: 'top'
      }
    }))));
  }

  useImperativeHandle(ref, function () {
    return {
      setVisible: function setVisible(visible) {
        _setVisible(visible);
      }
    };
  });
  return visible ? /*#__PURE__*/React.createElement(PageHeader, _extends({
    className: classnames('g3-page-header', className),
    extra: buttonExtra || extra
  }, rest)) : null;
};

export default /*#__PURE__*/React.forwardRef(G3PageHeader);