var _excluded = ["mode", "valueEnum", "render", "renderFormItem", "request", "fieldProps", "children", "proFieldKey"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useImperativeHandle, useRef, useEffect, useState } from 'react';
import { Space, Spin } from 'antd';
import { useIntl, useFieldFetchData, objToMap } from '@g3-cscec/app-sdk';
import G3Status, { G3FieldBadgeColor } from '../status/g3-status';
import SearchSelect from './SearchSelect';
export var g3FieldParsingText = function g3FieldParsingText(text, valueEnumParams) {
  if (text === null || text === undefined) {
    return '';
  }

  if (Array.isArray(text)) {
    return /*#__PURE__*/React.createElement(Space, null, text.map(function (value) {
      return /*#__PURE__*/React.createElement(React.Fragment, {
        key: (value === null || value === void 0 ? void 0 : value.value) || value
      }, g3FieldParsingText(value, valueEnumParams));
    }));
  }

  var valueEnum = objToMap(valueEnumParams);
  text = text + '';

  if (!valueEnum.has(text)) {
    return text;
  }

  var domText = valueEnum.get(text);

  if (!domText) {
    var _text;

    return ((_text = text) === null || _text === void 0 ? void 0 : _text.label) || text;
  }

  var status = domText.status,
      color = domText.color;
  var Status = G3Status[status || 'Init'];

  if (Status) {
    return /*#__PURE__*/React.createElement(Status, null, domText.text);
  }

  if (color) {
    return /*#__PURE__*/React.createElement(G3FieldBadgeColor, {
      color: color
    }, domText.text);
  }

  return domText.text || domText;
};

var G3FieldSelect = function G3FieldSelect(props, ref) {
  var _props$mode = props.mode,
      mode = _props$mode === void 0 ? 'edit' : _props$mode,
      valueEnum = props.valueEnum,
      render = props.render,
      renderFormItem = props.renderFormItem,
      request = props.request,
      fieldProps = props.fieldProps,
      children = props.children,
      proFieldKey = props.proFieldKey,
      rest = _objectWithoutProperties(props, _excluded);

  var inputRef = useRef({
    focus: function focus() {}
  });
  var intl = useIntl();

  var _useState = useState(fieldProps === null || fieldProps === void 0 ? void 0 : fieldProps.open),
      _useState2 = _slicedToArray(_useState, 2),
      open = _useState2[0],
      setOpen = _useState2[1];

  var keyWordsRef = useRef('');
  useEffect(function () {
    keyWordsRef.current = fieldProps === null || fieldProps === void 0 ? void 0 : fieldProps.searchValue;
  }, [fieldProps === null || fieldProps === void 0 ? void 0 : fieldProps.searchValue]);

  var _useFieldFetchData = useFieldFetchData(props),
      _useFieldFetchData2 = _slicedToArray(_useFieldFetchData, 4),
      loading = _useFieldFetchData2[0],
      options = _useFieldFetchData2[1],
      _fetchData = _useFieldFetchData2[2],
      resetData = _useFieldFetchData2[3];

  useImperativeHandle(ref, function () {
    return _objectSpread(_objectSpread({}, inputRef.current || {}), {}, {
      focus: function focus() {
        inputRef.current.focus();
        setOpen(true);
      },
      fetchData: function fetchData() {
        return _fetchData();
      }
    });
  });

  if (mode === 'read') {
    var _rest$text;

    var optionsValueEnum = (options === null || options === void 0 ? void 0 : options.length) ? options === null || options === void 0 ? void 0 : options.reduce(function (pre, cur) {
      return _objectSpread(_objectSpread({}, pre), {}, _defineProperty({}, cur.value, cur.label));
    }, {}) : undefined;

    if (loading) {
      return /*#__PURE__*/React.createElement(Spin, {
        size: "small"
      });
    }

    if ((_rest$text = rest.text) === null || _rest$text === void 0 ? void 0 : _rest$text.label) {
      var _rest$text2;

      return (_rest$text2 = rest.text) === null || _rest$text2 === void 0 ? void 0 : _rest$text2.label;
    }

    var dom = /*#__PURE__*/React.createElement(React.Fragment, null, g3FieldParsingText(rest.text, objToMap(optionsValueEnum)));

    if (render) {
      return render(rest.text, _objectSpread({
        mode: mode
      }, fieldProps), dom) || null;
    }

    return dom;
  }

  if (mode === 'edit' || mode === 'update') {
    var placeHolderText = intl.getMessage('tableForm.selectPlaceholder', '请选择');

    var renderDom = function renderDom() {
      return /*#__PURE__*/React.createElement(SearchSelect, _extends({
        key: "SearchSelect",
        style: {
          minWidth: 100
        },
        allowClear: true,
        loading: loading,
        placeholder: placeHolderText,
        ref: inputRef,
        notFoundContent: loading ? /*#__PURE__*/React.createElement(Spin, {
          size: "small"
        }) : fieldProps === null || fieldProps === void 0 ? void 0 : fieldProps.notFoundContent,
        fetchData: function fetchData(keyWord) {
          keyWordsRef.current = keyWord;

          _fetchData(keyWord);
        },
        resetData: resetData
      }, rest, fieldProps, {
        options: options,
        open: open,
        onDropdownVisibleChange: setOpen
      }));
    };

    var _dom = renderDom();

    if (renderFormItem) {
      return renderFormItem(rest.text, _objectSpread(_objectSpread({
        mode: mode
      }, fieldProps), {}, {
        options: options
      }), _dom) || null;
    }

    return _dom;
  }

  return null;
};

export default /*#__PURE__*/React.forwardRef(G3FieldSelect);