var _excluded = ["search", "treeData"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useImperativeHandle, useMemo, useState } from 'react';
import { Tree, Input } from 'antd';
import { get, isString } from 'lodash';
import "./index.css";
var Search = Input.Search;

var G3Tree = function G3Tree(props, ref) {
  var search = props.search,
      _props$treeData = props.treeData,
      treeData = _props$treeData === void 0 ? [] : _props$treeData,
      rest = _objectWithoutProperties(props, _excluded);

  var _useState = useState(true),
      _useState2 = _slicedToArray(_useState, 2),
      visible = _useState2[0],
      _setVisible = _useState2[1];

  var _useState3 = useState(''),
      _useState4 = _slicedToArray(_useState3, 2),
      keywords = _useState4[0],
      setKeywords = _useState4[1];

  var _useState5 = useState(get(props, 'autoExpandParent', false)),
      _useState6 = _slicedToArray(_useState5, 2),
      autoExpandParent = _useState6[0],
      setAutoExpandParent = _useState6[1];

  var _useState7 = useState(get(props, 'expandedKeys', [])),
      _useState8 = _slicedToArray(_useState7, 2),
      expandedKeys = _useState8[0],
      setExpandedKeys = _useState8[1];

  var flatKeyList = [];

  var generateList = function generateList(data) {
    for (var i = 0; i < data.length; i++) {
      var node = data[i];
      var key = node.key,
          title = node.title;
      flatKeyList.push({
        key: key,
        title: title
      });

      if (node.children) {
        generateList(node.children);
      }
    }
  };

  generateList(treeData);

  var loop = function loop(data) {
    return data.map(function (item) {
      var title = item.title;
      var searchTitle;

      if (isString(title) && keywords) {
        var index = title.indexOf(keywords);
        var beforeStr = title.substr(0, index);
        var afterStr = title.substr(index + keywords.length);
        searchTitle = index > -1 ? /*#__PURE__*/React.createElement("span", null, beforeStr, /*#__PURE__*/React.createElement("span", {
          className: "site-tree-search-value"
        }, keywords), afterStr) : /*#__PURE__*/React.createElement("span", null, title);
      }

      if (item.children) {
        return {
          title: searchTitle || title,
          key: item.key,
          children: loop(item.children)
        };
      }

      return {
        title: searchTitle || title,
        key: item.key
      };
    });
  };

  var getParentKey = function getParentKey(key, tree) {
    var parentKey;

    for (var i = 0; i < tree.length; i++) {
      var node = tree[i];

      if (node.children) {
        if (node.children.some(function (item) {
          return item.key === key;
        })) {
          parentKey = node.key;
        } else if (getParentKey(key, node.children)) {
          parentKey = getParentKey(key, node.children);
        }
      }
    }

    return parentKey;
  };

  var getExpandedKeys = function getExpandedKeys(keyList) {
    return keyList.map(function (item) {
      if (isString(item.title) && item.title.indexOf(keywords) > -1) {
        return getParentKey(item.key, treeData);
      }

      return null;
    }).filter(function (item, i, self) {
      return item && self.indexOf(item) === i;
    });
  };

  var renderTreeData = useMemo(function () {
    return loop(treeData);
  }, [keywords]);
  var renderExpandedKeys = useMemo(function () {
    return getExpandedKeys(flatKeyList);
  }, [keywords]);

  var onSearchChange = function onSearchChange(e) {
    var keywords = get(e, 'target.value', '');
    setKeywords(keywords);
    setExpandedKeys(renderExpandedKeys);
    setAutoExpandParent(true);
  };

  var onExpand = function onExpand(expandedKeys) {
    setExpandedKeys(expandedKeys);
    setAutoExpandParent(false);
  };

  useImperativeHandle(ref, function () {
    return {
      setVisible: function setVisible(visible) {
        _setVisible(visible);
      }
    };
  });
  return visible ? /*#__PURE__*/React.createElement("div", {
    className: "gs-tree"
  }, search ? /*#__PURE__*/React.createElement(Search, {
    allowClear: true,
    style: {
      marginBottom: 8
    },
    placeholder: get(search, 'placeholder', '搜索'),
    onChange: onSearchChange
  }) : null, /*#__PURE__*/React.createElement(Tree, _extends({
    onExpand: onExpand,
    expandedKeys: expandedKeys,
    autoExpandParent: autoExpandParent,
    treeData: renderTreeData
  }, rest))) : null;
};

export default /*#__PURE__*/React.forwardRef(G3Tree);