var _excluded = ["label", "value", "children"],
    _excluded2 = ["label", "children"],
    _excluded3 = ["mode", "valueEnum", "render", "renderFormItem", "request", "fieldProps", "children", "proFieldKey"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState, useImperativeHandle, useRef, useEffect, useMemo } from 'react';
import { Space, Spin, TreeSelect } from 'antd';
import useSWR, { mutate } from 'swr';
import { swrIncrementTestId, useIntl, useDeepCompareEffect, useMountMergeState } from '@g3-cscec/app-sdk';

var getTreeDataFromValueEnum = function getTreeDataFromValueEnum(valueEnum) {
  if (Array.isArray(valueEnum) && valueEnum.length > 0) {
    return valueEnum.map(function (item) {
      var label = item.label,
          value = item.value,
          children = item.children,
          rest = _objectWithoutProperties(item, _excluded);

      return _objectSpread({
        title: label,
        label: label,
        value: value,
        key: value,
        children: getTreeDataFromValueEnum(children)
      }, rest);
    });
  }

  return undefined;
};

var treeDataToArray = function treeDataToArray(valueEnum) {
  var parentStr = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var result = [];

  if (Array.isArray(valueEnum) && valueEnum.length) {
    valueEnum.forEach(function (item) {
      var label = item.label,
          children = item.children,
          rest = _objectWithoutProperties(item, _excluded2);

      var tmpSysPath = "".concat(parentStr, "/").concat(label);
      result.push(_objectSpread({
        sysPath: tmpSysPath,
        label: label
      }, rest));
      var tmpResult = treeDataToArray(children, tmpSysPath);
      Array.isArray(tmpResult) && result.push.apply(result, _toConsumableArray(tmpResult));
    });
    return result;
  }

  return undefined;
};

export var g3FieldParsingText = function g3FieldParsingText(text, valueEnumParams) {
  if (text === undefined || text === null) {
    return '';
  }

  if (Array.isArray(text)) {
    return /*#__PURE__*/React.createElement(Space, null, text.map(function (value) {
      return /*#__PURE__*/React.createElement(React.Fragment, {
        key: (value === null || value === void 0 ? void 0 : value.value) || value
      }, g3FieldParsingText(value, valueEnumParams));
    }));
  }

  var valueEnum = treeDataToArray(valueEnumParams);

  if (!valueEnum) {
    return text;
  }

  var domText = valueEnum.find(function (item) {
    return item.value === text;
  });

  if (!domText) {
    return (text === null || text === void 0 ? void 0 : text.label) || text;
  }

  return domText.sysPath;
};
export var useFieldTreeSelectFetchData = function useFieldTreeSelectFetchData(props) {
  var _props$fieldProps;

  var _useState = useState(undefined),
      _useState2 = _slicedToArray(_useState, 2),
      keyWords = _useState2[0],
      setKeyWords = _useState2[1];

  var _useState3 = useState(function () {
    if (props.proFieldKey) {
      return props.proFieldKey.toString();
    }

    if (props.request) {
      var testId = swrIncrementTestId();
      return testId.toString();
    }

    return 'no-fetch';
  }),
      _useState4 = _slicedToArray(_useState3, 1),
      cacheKey = _useState4[0];

  var proFieldKeyRef = useRef(cacheKey);

  var _useMountMergeState = useMountMergeState(function () {
    if (Array.isArray(props.valueEnum)) {
      return getTreeDataFromValueEnum(props.valueEnum);
    }

    return [];
  }, {
    value: (_props$fieldProps = props.fieldProps) === null || _props$fieldProps === void 0 ? void 0 : _props$fieldProps.options
  }),
      _useMountMergeState2 = _slicedToArray(_useMountMergeState, 2),
      options = _useMountMergeState2[0],
      setOptions = _useMountMergeState2[1];

  useDeepCompareEffect(function () {
    var _props$fieldProps2;

    if (!props.valueEnum || ((_props$fieldProps2 = props.fieldProps) === null || _props$fieldProps2 === void 0 ? void 0 : _props$fieldProps2.options)) return;
    setOptions(getTreeDataFromValueEnum(props.valueEnum));
  }, [props.valueEnum]);

  var _useState5 = useState(false),
      _useState6 = _slicedToArray(_useState5, 2),
      loading = _useState6[0],
      setLoading = _useState6[1];

  var fetchData = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var loadData;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (props.request) {
                _context.next = 2;
                break;
              }

              return _context.abrupt("return", []);

            case 2:
              setLoading(true);
              _context.next = 5;
              return props.request(_objectSpread(_objectSpread({}, props.params), {}, {
                keyWords: keyWords
              }), props);

            case 5:
              loadData = _context.sent;
              setLoading(false);
              return _context.abrupt("return", getTreeDataFromValueEnum(loadData));

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function fetchData() {
      return _ref.apply(this, arguments);
    };
  }();

  var key = useMemo(function () {
    if (!props.request) {
      return 'no-fetch';
    }

    if (!props.params && !keyWords) {
      return proFieldKeyRef.current;
    }

    return [proFieldKeyRef.current, JSON.stringify(_objectSpread(_objectSpread({}, props.params), {}, {
      keyWords: keyWords
    }))];
  }, [keyWords, props.params, props.request]);

  var _useSWR = useSWR(key, fetchData, {
    revalidateOnFocus: false,
    shouldRetryOnError: false,
    revalidateOnReconnect: false
  }),
      data = _useSWR.data,
      setLocaleData = _useSWR.mutate;

  return [loading, props.request ? data : options, function (fetchKeyWords) {
    setKeyWords(fetchKeyWords);
    mutate(key);
  }, function () {
    setKeyWords(undefined);
    setLocaleData( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              return _context2.abrupt("return", []);

            case 1:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    })), false);
  }];
};

var G3FieldTreeSelect = function G3FieldTreeSelect(props, ref) {
  var mode = props.mode,
      valueEnum = props.valueEnum,
      render = props.render,
      renderFormItem = props.renderFormItem,
      request = props.request,
      fieldProps = props.fieldProps,
      children = props.children,
      proFieldKey = props.proFieldKey,
      rest = _objectWithoutProperties(props, _excluded3);

  var inputRef = useRef();
  var intl = useIntl();
  var keyWordsRef = useRef('');
  useEffect(function () {
    keyWordsRef.current = fieldProps === null || fieldProps === void 0 ? void 0 : fieldProps.searchValue;
  }, [fieldProps === null || fieldProps === void 0 ? void 0 : fieldProps.searchValue]);

  var _useFieldTreeSelectFe = useFieldTreeSelectFetchData(props),
      _useFieldTreeSelectFe2 = _slicedToArray(_useFieldTreeSelectFe, 4),
      loading = _useFieldTreeSelectFe2[0],
      options = _useFieldTreeSelectFe2[1],
      _fetchData = _useFieldTreeSelectFe2[2],
      resetData = _useFieldTreeSelectFe2[3];

  useImperativeHandle(ref, function () {
    return _objectSpread(_objectSpread({}, inputRef.current || {}), {}, {
      fetchData: function fetchData() {
        return _fetchData();
      }
    });
  });

  if (mode === 'read') {
    var _rest$text;

    var optionsValueEnum = (options === null || options === void 0 ? void 0 : options.length) ? options : undefined;

    if (loading) {
      return /*#__PURE__*/React.createElement(Spin, {
        size: "small"
      });
    }

    if ((_rest$text = rest.text) === null || _rest$text === void 0 ? void 0 : _rest$text.label) {
      var _rest$text2;

      return (_rest$text2 = rest.text) === null || _rest$text2 === void 0 ? void 0 : _rest$text2.label;
    }

    var dom = /*#__PURE__*/React.createElement(React.Fragment, null, g3FieldParsingText(rest.text, optionsValueEnum));

    if (render) {
      return render(rest.text, _objectSpread({
        mode: mode
      }, fieldProps), dom) || null;
    }

    return dom;
  }

  if (mode === 'edit' || mode === 'update') {
    var placeHolderText = intl.getMessage('tableForm.selectPlaceholder', '请选择');

    var renderDom = function renderDom() {
      return /*#__PURE__*/React.createElement(TreeSelect, _extends({
        style: {
          minWidth: 160
        },
        allowClear: true,
        placeholder: placeHolderText,
        ref: inputRef,
        notFoundContent: loading ? /*#__PURE__*/React.createElement(Spin, {
          size: "small"
        }) : fieldProps === null || fieldProps === void 0 ? void 0 : fieldProps.notFoundContent
      }, rest, fieldProps, {
        treeData: options
      }));
    };

    var _dom = renderDom();

    if (renderFormItem) {
      return renderFormItem(rest.text, _objectSpread(_objectSpread({
        mode: mode
      }, fieldProps), {}, {
        options: options
      }), _dom) || null;
    }

    return _dom;
  }

  return null;
};

export default /*#__PURE__*/React.forwardRef(G3FieldTreeSelect);