import React from 'react';
import type { SelectProps } from 'antd';
import type { RequestOptionsType } from '../types';
export interface LabeledValue {
    key?: string;
    value: React.ReactText;
    label: React.ReactNode;
}
export declare type KeyLabel = Partial<LabeledValue> & RequestOptionsType;
export declare type DataValueType<T> = KeyLabel & T;
export declare type DataValuesType<T> = DataValueType<T> | DataValueType<T>[];
export interface SearchSelectProps<T = Record<string, any>> extends Omit<SelectProps<KeyLabel | KeyLabel[]>, 'options'> {
    request?: (params: {
        query: string;
    }) => Promise<DataValueType<T>[]>;
    optionItemRender?: (item: DataValueType<T>) => React.ReactNode;
    value?: KeyLabel | KeyLabel[];
    defaultValue?: KeyLabel | KeyLabel[];
    options?: RequestOptionsType[];
    style?: React.CSSProperties;
    className?: string;
    placeholder?: any;
    searchOnFocus?: boolean;
    resetAfterSelect?: boolean;
    prefixCls?: string;
    fetchData: (keyWord: string) => void;
    resetData: () => void;
}
declare const _default: React.ForwardRefExoticComponent<SearchSelectProps<unknown[]> & React.RefAttributes<unknown>>;
export default _default;
